<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content injectable">
                   <div class="content-data">







<ol class="breadcrumb">
  <li>Injectables</li>
  <li>HttpParameters</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/core/service/http/http.parameters.service.ts</code>
        </p>



            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#apiBaseURL">apiBaseURL</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#paramListToParamObject">paramListToParamObject</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#stopBackgroundRequest">stopBackgroundRequest</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#translateMessages">translateMessages</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Static</span>
                                <a href="#getFileNameFromHeader">getFileNameFromHeader</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(baseUrlService: <a href="../injectables/BaseUrlService.html">BaseUrlService</a>, translate: TranslateService)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="48" class="link-to-prism">src/app/core/service/http/http.parameters.service.ts:48</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>baseUrlService</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/BaseUrlService.html" target="_self" >BaseUrlService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>translate</td>
                                                  
                                                        <td>
                                                                    <code>TranslateService</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="getFileNameFromHeader"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Static</span>
                            getFileNameFromHeader
                            </b>
                            <a href="#getFileNameFromHeader"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>getFileNameFromHeader(response: HttpResponse<any>)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="69" class="link-to-prism">src/app/core/service/http/http.parameters.service.ts:69</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">
                            <div class="io-description"><p>Parse an HTTP response header to extract the file name.</p>
</div>

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                                    <td>Description</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>response</td>
                                                        <td>
                                                                    <code>HttpResponse&lt;any&gt;</code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                        <td>
                                                                <code><p>the HTTP response</p>
</code>
                                                        </td>
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>

                            </div>
                                <div class="io-description">
                                    <p>the filename extracted from the response</p>

                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="apiBaseURL"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Public</span>
                            apiBaseURL
                            </b>
                            <a href="#apiBaseURL"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>apiBaseURL:     <code></code>
</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="13" class="link-to-prism">src/app/core/service/http/http.parameters.service.ts:13</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="paramListToParamObject"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            paramListToParamObject
                            </b>
                            <a href="#paramListToParamObject"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>paramListToParamObject:     <code></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>(error: GlobalValidationErrorModel | FieldValidationErrorModel) &#x3D;&gt; {
    let paramMap &#x3D; {};
    if (error.messageParams) {
      let i: number &#x3D; 0;
      error.messageParams.forEach(param &#x3D;&gt; {
        paramMap[&quot;param&quot; + i] &#x3D; param;
        i++
      });
    }
    return paramMap;
  }</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="38" class="link-to-prism">src/app/core/service/http/http.parameters.service.ts:38</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                        <div class="io-description"><p>Convert a list of string into an object with properties named param<index></p>
</div>
                    </td>
                </tr>

                    <tr>
                        <td class="col-md-4">
                          <div class="io-description">
                                  <b>Parameters :</b>
                                  <table class="params">
                                      <thead>
                                          <tr>
                                                <td>Name</td>
                                          </tr>
                                      </thead>
                                      <tbody>
                                                <tr>
                                                        <td>error</td>
                                                </tr>
                                      </tbody>
                                  </table>
                          </div>
                        </td>
                    </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="stopBackgroundRequest"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Public</span>
                            stopBackgroundRequest
                            </b>
                            <a href="#stopBackgroundRequest"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>stopBackgroundRequest:     <code></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>new BehaviorSubject&lt;boolean&gt;(false)</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="14" class="link-to-prism">src/app/core/service/http/http.parameters.service.ts:14</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="translateMessages"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Public</span>
                            translateMessages
                            </b>
                            <a href="#translateMessages"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>translateMessages:     <code></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>(validationErrorModel) &#x3D;&gt; {
    validationErrorModel.globalErrors.forEach(globalError &#x3D;&gt; {
      let paramMap &#x3D; this.paramListToParamObject(globalError);
      this.translate.get(globalError.messageKey, paramMap).subscribe((translatedMessage: string) &#x3D;&gt; {
        globalError.message &#x3D; translatedMessage;
      });
    });
    validationErrorModel.fieldErrors.forEach(fieldError &#x3D;&gt; {
      let paramMap &#x3D; this.paramListToParamObject(fieldError);
      this.translate.get(fieldError.messageKey, paramMap).subscribe((translatedMessage: string) &#x3D;&gt; {
        fieldError.message &#x3D; translatedMessage;
      });
    });
  }</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="19" class="link-to-prism">src/app/core/service/http/http.parameters.service.ts:19</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                        <div class="io-description"><p>Translate error message using translation service. Translated message is stored in error.message</p>
</div>
                    </td>
                </tr>

                    <tr>
                        <td class="col-md-4">
                          <div class="io-description">
                                  <b>Parameters :</b>
                                  <table class="params">
                                      <thead>
                                          <tr>
                                                <td>Name</td>
                                          </tr>
                                      </thead>
                                      <tbody>
                                                <tr>
                                                        <td>validationErrorModel</td>
                                                </tr>
                                      </tbody>
                                  </table>
                          </div>
                        </td>
                    </tr>
            </tbody>
        </table>
</section>

    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Injectable } from &quot;@angular/core&quot;;
import { BaseUrlService } from &#x27;../base-url/base-url.service&#x27;;
import { HttpResponse } from &#x27;@angular/common/http&#x27;;
import { TranslateService } from &#x27;@ngx-translate/core&#x27;;
import { FieldValidationErrorModel } from &#x27;./field.validation.error.model&#x27;;
import { GlobalValidationErrorModel } from &#x27;./global.validation.error.model&#x27;;
import { padNumber } from &#x27;../../util/utils&#x27;;
import { BehaviorSubject } from &#x27;rxjs/BehaviorSubject&#x27;;


@Injectable()
export class HttpParameters {
  public apiBaseURL;
  public stopBackgroundRequest &#x3D; new BehaviorSubject&lt;boolean&gt;(false);
  /**
   * Translate error message using translation service. Translated message is stored in error.message
   * @param validationErrorModel
   */
  public translateMessages &#x3D; (validationErrorModel) &#x3D;&gt; {
    validationErrorModel.globalErrors.forEach(globalError &#x3D;&gt; {
      let paramMap &#x3D; this.paramListToParamObject(globalError);
      this.translate.get(globalError.messageKey, paramMap).subscribe((translatedMessage: string) &#x3D;&gt; {
        globalError.message &#x3D; translatedMessage;
      });
    });
    validationErrorModel.fieldErrors.forEach(fieldError &#x3D;&gt; {
      let paramMap &#x3D; this.paramListToParamObject(fieldError);
      this.translate.get(fieldError.messageKey, paramMap).subscribe((translatedMessage: string) &#x3D;&gt; {
        fieldError.message &#x3D; translatedMessage;
      });
    });
  };
  /**
   * Convert a list of string into an object with properties named param&lt;index&gt;
   * @param error
   * @returns an object whose properties are named param&lt;index&gt;, one property for each message params of error
   */
  private paramListToParamObject &#x3D; (error: GlobalValidationErrorModel | FieldValidationErrorModel) &#x3D;&gt; {
    let paramMap &#x3D; {};
    if (error.messageParams) {
      let i: number &#x3D; 0;
      error.messageParams.forEach(param &#x3D;&gt; {
        paramMap[&quot;param&quot; + i] &#x3D; param;
        i++
      });
    }
    return paramMap;
  };

  constructor(private baseUrlService: BaseUrlService, private translate: TranslateService) {
    this.apiBaseURL &#x3D; baseUrlService.getBackendBaseUrl();
    Date.prototype.toJSON &#x3D; function () {
      let day &#x3D; padNumber(this.getDate(), 2);
      let month &#x3D; padNumber(this.getMonth() + 1, 2);
      let hours &#x3D; padNumber(this.getHours(), 2);
      let minutes &#x3D; padNumber(this.getMinutes(), 2);
      let seconds &#x3D; padNumber(this.getSeconds(), 2);
      let milliseconds &#x3D; padNumber(this.getMilliseconds(), 3);
      return &#x60;JSDate[${day}.${month}.${this.getFullYear()} ${hours}:${minutes}:${seconds}.${milliseconds}]&#x60;;
    };
  }

  /**
   * Parse an HTTP response header to extract the file name.
   *
   * @param response the HTTP response
   * @returns {String} the filename extracted from the response
   */
  static getFileNameFromHeader(response: HttpResponse&lt;any&gt;): string {
    let header &#x3D; response.headers.get(&#x27;content-disposition&#x27;);
    let fileName &#x3D; header.split(&quot;;&quot;)[1].trim().split(&quot;&#x3D;&quot;)[1];
    return fileName.replace(/&quot;/g, &#x27;&#x27;);
  }

}
</code></pre>
    </div>

</div>











                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'injectable';
            var COMPODOC_CURRENT_PAGE_URL = 'HttpParameters.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
